unit MakeDatU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  TypInfo, Db, DBTables, StdCtrls, ExtCtrls, rbUtils, ComCtrls, NdbBasDS,
  NdbAsaDS, NdbBase, NdbAsa;

type
  TfmMain = class(TForm)
    Table1: TTable;
    btnCopyData: TButton;
    gbSource: TGroupBox;
    cbSourceAlias: TComboBox;
    cbSourceTable: TComboBox;
    gbDestination: TGroupBox;
    edDestTable: TEdit;
    cbDestAlias: TComboBox;
    Label3: TLabel;
    Label4: TLabel;
    ProgressBar1: TProgressBar;
    AsaSession1: TAsaSession;
    adCreate: TAsaDataset;
    adDrop: TAsaDataset;
    adInsert: TAsaDataset;
    procedure FormCreate(Sender: TObject);
    procedure cbSourceAliasChange(Sender: TObject);
    procedure btnCopyDataClick(Sender: TObject);
    procedure cbSourceTableChange(Sender: TObject);
  private
    { Private declarations }
    FWorking : Boolean;
    procedure CreateDestTable;
    procedure CopyRecords;
  public
    { Public declarations }
  end;

var
  fmMain: TfmMain;

implementation

{$R *.DFM}

procedure TfmMain.FormCreate(Sender: TObject);
begin
 Session.GetAliasNames(cbSourceAlias.Items);
 Session.GetAliasNames(cbDestAlias.Items);
 with cbSourceAlias do
  begin
   ItemIndex := Items.IndexOf('Rubicon2');
   if ItemIndex <> -1 then
    cbSourceAliasChange(nil)
  end;
 with cbSourceTable do
  begin
   ItemIndex := Items.IndexOf('help.db');
   if ItemIndex <> -1 then
    cbSourceTableChange(nil)
  end;
 cbDestAlias.Text := AsaSession1.LoginDatabase;
 Application.Icon := Icon;
 Application.Title := 'Make Data'
end;

procedure TfmMain.cbSourceAliasChange(Sender: TObject);
begin
 DBTables.Session.GetTableNames(cbSourceAlias.Text,'',True,False,cbSourceTable.Items)
end;

procedure TfmMain.cbSourceTableChange(Sender: TObject);
begin
 edDestTable.Text := CopyUntil(cbSourceTable.Text,'.');
 with Table1 do
  begin
   Close;
   DatabaseName := cbSourceAlias.Text;
   TableName := cbSourceTable.Text;
   Open;
  end;
end;

procedure TfmMain.CreateDestTable;
begin
 AsaSession1.Connected := True;
 try
  adDrop.ExecSQL;
 except
 end;
 adCreate.ExecSQL;
 adInsert.Close;
 adInsert.Open;
end;

procedure TfmMain.CopyRecords;
var
  i : Integer;
begin
 with ProgressBar1 do
  begin
   Max := Table1.RecordCount;
   Position := 0;
   Visible := True
  end;
 Screen.Cursor := crHourglass;
 try
  Table1.First;
  while not Table1.Eof do
   begin
    with adInsert do
     begin
      Append;
      for i := 0 to FieldCount - 1 do
       Fields[i].Assign(Table1.Fields[i]);
      Post
     end;
    with ProgressBar1 do
     Position := Position + 1;
    Application.ProcessMessages;
    Table1.Next
   end;
 finally
  Screen.Cursor := crDefault
 end
end;

procedure TfmMain.btnCopyDataClick(Sender: TObject);
begin
 if FWorking then
  FWorking := False
 else
  begin
   FWorking := True;
   try
    Table1.Open;
    CreateDestTable;
    AsaSession1.StartTransaction;
    CopyRecords;
    AsaSession1.Commit
   finally
    FWorking := False
   end
  end
end;

end.
