{*********************************************************}
{*                    EXUPDU.PAS 2.11                    *}
{*       Copyright (c) Tamarack Associates 1996 - 2002.	 *}
{*                  All rights reserved.                 *}
{*       Modified with permission by Liodden Data AS     *}
{*********************************************************}

{$B-}	 {* Boolean evaluation *}
{$X+}	 {* eXtended syntax    *}

unit ExUpdU;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DB, DBCtrls, Grids, DBGrids, Tabs,
  ExtCtrls, rbBase, rbBits, rbCache, rbUpdate, rbDS,
  rbAccept, rbSQL, rbNDB, NdbBase, NdbAsa, NdbBasDS, NdbAsaDS;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    Panel1: TPanel;
    TabSet1: TTabSet;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    rbUpdate1: TrbUpdate;
    rbCache1: TrbCache;
    rbAccept1: TrbAccept;
    AsaDataset3: TAsaDataset;
    AsaSession1: TAsaSession;
    AsaDataset2: TAsaDataset;
    rbAsaDataSet1: TrbAsaDataSet;
    rbTextNDBLink1: TrbTextNDBLink;
    rbWordsNDBLink1: TrbWordsNDBLink;
    procedure TabSet1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    function rbUpdate1AcceptWord(Sender: TObject;
      const Word: String): Boolean;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses ExDBMemo;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var       SaveSQL : String;
begin
 AsaSession1.Connected := True;
 {* Here are the steps that need to be followed to prepare for editing *}
 {* Save the SQL as the query will be used by Rubicon to perform some initialization *}
 SaveSQL := rbAsaDataSet1.SQL.Text;
 {* Initialize Rubicon *}
 rbUpdate1.Initialize;
 {* Restore the SQL *}
 rbAsaDataSet1.SQL.Text := SaveSQL;
 {* Very Important: Open the query through the TextLink as this insures *}
 {* that Rubicon knows the DataSet is open!                             *}
 rbTextNDBLink1.Open;
 Application.Icon := Icon;
end;

procedure TForm1.TabSet1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
 AllowChange := True;
 case NewTab of
  0 : DBGrid1.DataSource := DataSource1;
  1 : begin
       rbUpdate1.FlushCache;
       if AsaDataSet3.Active then
         // Nice NativeDB feature to avoid loosing the current row from view
         AsaDataSet3.Refresh
       else
         AsaDataSet3.Open;
       DBGrid1.DataSource := DataSource2;
      end
 end;
 DBGrid1.ReadOnly := DBGrid1.DataSource = DataSource2;
 DBNavigator1.DataSource := DBGrid1.DataSource
end;

procedure TForm1.DBGrid1DblClick(Sender: TObject);
begin
 DBGrid1.SelectedField.ReadOnly := DBGrid1.ReadOnly;
 Form2.ShowMemo(DBGrid1.DataSource,DBGrid1.SelectedField)
end;

function TForm1.rbUpdate1AcceptWord(Sender: TObject;
  const Word: String): Boolean;
begin
 rbAccept1.Word := Word;
 Result := rbAccept1.Accept
end;

end.
